"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.conflictTypes = exports.newTypes = void 0;

var _core = require("@babel/core");

var _eslintVisitorKeys = require("eslint-visitor-keys");

const newTypes = {
  ChainExpression: _eslintVisitorKeys.KEYS.ChainExpression,
  ImportExpression: _eslintVisitorKeys.KEYS.ImportExpression,
  Literal: _eslintVisitorKeys.KEYS.Literal,
  MethodDefinition: ["decorators"].concat(_eslintVisitorKeys.KEYS.MethodDefinition),
  Property: ["decorators"].concat(_eslintVisitorKeys.KEYS.Property)
};
exports.newTypes = newTypes;
const conflictTypes = {
  ClassPrivateMethod: ["decorators"].concat(_eslintVisitorKeys.KEYS.MethodDefinition),
  ExportAllDeclaration: _eslintVisitorKeys.KEYS.ExportAllDeclaration
};
exports.conflictTypes = conflictTypes;

var _default = Object.assign({}, newTypes, _core.types.VISITOR_KEYS, conflictTypes);

exports.default = _default;