import type { CallExpression, Expression, OptionalCallExpression, SpreadElement } from "@babel/types";
/**
 * A helper function that generates a new call expression with given thisNode.
 It will also optimize `(...arguments)` to `.apply(arguments)`
 *
 * @export
 * @param {Expression} callee The callee of call expression
 * @param {Expression} thisNode The desired this of call expression
 * @param {Readonly<Array<Expression | SpreadElement>>} args The arguments of call expression
 * @param {boolean} optional Whether the call expression is optional
 * @returns {CallExpression | OptionalCallExpression} The generated new call expression
 */
export default function optimiseCallExpression(callee: Expression, thisNode: Expression, args: Readonly<Array<Expression | SpreadElement>>, optional: boolean): CallExpression | OptionalCallExpression;
//# sourceMappingURL=index.d.ts.map