export declare class OptionValidator {
    descriptor: string;
    constructor(descriptor: string);
    /**
     * Validate if the given `options` follow the name of keys defined in the `TopLevelOptionShape`
     *
     * @param {Object} options
     * @param {Object} TopLevelOptionShape
     *   An object with all the valid key names that `options` should be allowed to have
     *   The property values of `TopLevelOptionShape` can be arbitrary
     * @memberof OptionValidator
     */
    validateTopLevelOptions(options: Object, TopLevelOptionShape: Object): void;
    validateBooleanOption<T>(name: string, value?: boolean, defaultValue?: T): boolean | T;
    validateStringOption<T>(name: string, value?: string, defaultValue?: T): string | T;
    /**
     * A helper interface copied from the `invariant` npm package.
     * It throws given `message` when `condition` is not met
     *
     * @param {boolean} condition
     * @param {string} message
     * @memberof OptionValidator
     */
    invariant(condition: boolean, message: string): void;
    formatMessage(message: string): string;
}
//# sourceMappingURL=validator.d.ts.map