import type { TemplateOpts, PublicOpts, PublicReplacements } from "./options";
import type { Formatter } from "./formatters";
export declare type TemplateBuilder<T> = {
    (opts: PublicOpts): TemplateBuilder<T>;
    (tpl: string, opts?: PublicOpts): (replacements?: PublicReplacements) => T;
    (tpl: TemplateStringsArray, ...args: Array<any>): (replacements?: PublicReplacements) => T;
    ast: {
        (tpl: string, opts?: PublicOpts): T;
        (tpl: TemplateStringsArray, ...args: Array<any>): T;
    };
};
export default function createTemplateBuilder<T>(formatter: Formatter<T>, defaultOpts?: TemplateOpts): TemplateBuilder<T>;
//# sourceMappingURL=builder.d.ts.map